<?php

namespace Nelio_AB_Testing\Experiment_Library\WooCommerce\Product_Summary_Experiment;

defined( 'ABSPATH' ) || exit;

use \add_filter;
use \is_wp_error;

add_filter( 'nab_nab/product-summary_get_tested_element', '\Nelio_AB_Testing\Experiment_Library\Headline_Experiment\get_tested_element', 10, 2 );

function backup_control( $backup, $control ) {

	if ( ! function_exists( '\wc_get_product' ) ) {
		return [];
	}//end if

	$product = \wc_get_product( $control['postId'] );
	if ( empty( $product ) || is_wp_error( $product ) ) {
		return [];
	}//end if

	$backup = array(
		'name'    => $product->get_name(),
		'excerpt' => $product->get_short_description(),
		'imageId' => absint( $product->get_image_id() ),
	);
	return $backup;

}//end backup_control()
add_filter( 'nab_nab/product-summary_backup_control', __NAMESPACE__ . '\backup_control', 10, 2 );

add_filter( 'nab_nab/product-summary_apply_alternative', '\Nelio_AB_Testing\Experiment_Library\Headline_Experiment\apply_alternative', 10, 5 );
